<p>
{{> theorie }}
Wir haben bereits gelernt, dass Beziehungen <span class="bold">Verknüpfungen</span> oder <span
    class="bold">Zusammenhänge</span> zwischen den Entitäten in einem Modell sichtbar machen. Dabei wird
unterschieden, wie vielen Entitäten eines Entitätstyps zu den Entitäten des zweiten Entitätstyps in
Beziehung stehen, um den Sachverhalt korrekt zu beschreiben. Die verschiedenen Anzahlen der Beziehungen
nennt man <b>Kardinalitäten</b>.
</p>
<p>
Beziehungen können sich also hinsichtlich ihrer <b>Kardinalität</b> unterscheiden. Folgende
Kardinalitäten werden unterschieden:
</p>
<div id="accordion" class="ovk-accordion">
<div class="card">
    <div class="card-header" id="headingOneOne">
        <button class="btn ovk-expand collapsed" data-bs-toggle="collapse" data-bs-target="#collapseOne"
            aria-expanded="false" aria-controls="collapseOne">
            1:1 Beziehung
        </button>
    </div>
    <div id="collapseOne" class="collapse show" aria-labelledby="headingOneOne"
        data-parent="#accordion">
        <div class="card-body">
            <p>
                In einer „eins zu eins“ Beziehung in relationalen Datenbanken ist jede Entität eines
                Entitätstyps <span class="bold">genau einer</span> Entität des anderen an der Beziehung
                beteiligten Entitätstyps zugeordnet <span class="bold">und umgekehrt</span>.
            </p>
            <b>Beispiele:</b>
            <ul class="ovk-list">
                <li>Ein Ehepartner ist in Deutschland mit <span class="bold">genau einem</span>
                    Ehepartner verheiratet.</li>
                <li>Ein zugelassenes Fahrzeug hat <span class="bold">genau einen</span> KFZ-Brief und
                    jeder KFZ-Brief gehört zu <span class="bold">genau einem</span> Fahrzeug.</li>
            </ul>
            <div>
                <?xml version="1.0" encoding="UTF-8" standalone="no"?>
                <!DOCTYPE svg
                    PUBLIC "-//W3C//DTD SVG 1.0//EN" "http://www.w3.org/TR/2001/PR-SVG-20010719/DTD/svg10.dtd">
                <svg class="ovk-grafik" style="margin-left: 2em;" width="12cm" viewBox="263 205 446 41"
                    xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
                    <g id="Hintergrund">
                        <g>
                            <rect class="ovk-svg-graphics entity" x="264" y="208" width="189.7"
                                height="36" />
                            <text font-size="12.8"
                                style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                                x="358.85" y="229.881">Zugelassenes Fahrzeug</text>
                        </g>
                        <g>
                            <polygon class="ovk-svg-graphics relationship" fill-rule="evenodd"
                                points="484,224.93 515.55,206 547.1,224.93 515.55,243.86 " />
                            <text font-size="12.8"
                                style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:end;font-family:monospace;font-style:normal;font-weight:normal"
                                x="478" y="218.93">1</text>
                            <text font-size="12.8"
                                style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:start;font-family:monospace;font-style:normal;font-weight:normal"
                                x="553.1" y="218.93">1</text>
                            <text font-size="12.8"
                                style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                                x="515.55" y="228.811">hat</text>
                        </g>
                        <g>
                            <rect class="ovk-svg-graphics entity" x="579.6" y="207.2" width="128.1"
                                height="36" />
                            <text font-size="12.8"
                                style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                                x="643.65" y="229.081">Fahrzeugbrief</text>
                        </g>
                        <line
                            style="fill: none; stroke-opacity: 1; stroke-width: 2; stroke-linecap: round; stroke: #000000"
                            x1="453.7" y1="226" x2="483.024" y2="225.493" />
                        <line
                            style="fill: none; stroke-opacity: 1; stroke-width: 2; stroke-linecap: round; stroke: #000000"
                            x1="547.1" y1="224.93" x2="579.6" y2="225.2" />
                    </g>
                </svg>
            </div>
        </div>
    </div>
</div>
<div class="card">
    <div class="card-header" id="headingOneMany">
        <button class="btn ovk-expand collapsed" data-bs-toggle="collapse" data-bs-target="#collapseTwo"
            aria-expanded="false" aria-controls="collapseTwo">
            1:n Beziehung
        </button>
    </div>
    <div id="collapseTwo" class="collapse" aria-labelledby="headingOneMany" data-parent="#accordion">
        <div class="card-body">
            <p>
                In einer „eins zu viele“ Beziehung können einer Entität eines Entitätstyps A mehrere
                Entitäten des anderen an der Beziehung beteiligten Entitätstyps B zugeordnet sein, aber
                einer Entität des Entitätstyps B ist nie mehr als eine Entität des Entitätstyps A
                zugeordnet.<br />
                <b>Beispiele:</b>
            <ul class="ovk-list">
                <li>
                    Ein Museum kann <b>mehrere</b> (=n) Kunstwerke gleichzeitig ausstellen. Jedes
                    Kunstwerk kann zu einem Zeitpunkt jedoch <span class="bold">nur in einem</span>
                    Museum ausgestellt werden.
                </li>
                <li>Ein Gebäude hat <span class="bold">mehrere</span> Räume, jedoch liegt ein Raum stets
                    <span class="bold">nur in einem</span> Gebäude.
                </li>
            </ul>
            <?xml version="1.0" encoding="UTF-8" standalone="no"?>
            <!DOCTYPE svg
                PUBLIC "-//W3C//DTD SVG 1.0//EN" "http://www.w3.org/TR/2001/PR-SVG-20010719/DTD/svg10.dtd">
            <svg class="ovk-grafik" style="margin-left: 2em;" width="9cm" viewBox="224 200 293 40"
                xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
                <g id="Hintergrund">
                    <g>
                        <rect class="ovk-svg-graphics entity" x="225" y="202" width="81.9"
                            height="36" />
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                            x="265.95" y="223.881">Gebäude</text>
                    </g>
                    <g>
                        <polygon class="ovk-svg-graphics relationship" fill-rule="evenodd"
                            points="347,219.93 378.55,201 410.1,219.93 378.55,238.86 " />
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:end;font-family:monospace;font-style:normal;font-weight:normal"
                            x="341" y="213.93">1</text>
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:start;font-family:monospace;font-style:normal;font-weight:normal"
                            x="416.1" y="213.93">n</text>
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                            x="378.55" y="223.811">hat</text>
                    </g>
                    <g>
                        <rect class="ovk-svg-graphics entity" x="456.6" y="202.2" width="58.8"
                            height="36" />
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                            x="486" y="224.081">Raum</text>
                    </g>
                    <line
                        style="fill: none; stroke-opacity: 1; stroke-width: 2; stroke-linecap: round; stroke: #000000"
                        x1="306.9" y1="220" x2="346.005" y2="219.962" />
                    <line
                        style="fill: none; stroke-opacity: 1; stroke-width: 2; stroke-linecap: round; stroke: #000000"
                        x1="410.1" y1="219.93" x2="455.601" y2="220.092" />
                </g>
            </svg>
        </div>
    </div>
</div>
<div class="card">
    <div class="card-header" id="headingManyMany">
        <button class="btn ovk-expand collapsed" data-bs-toggle="collapse"
            data-bs-target="#collapseThree" aria-expanded="false" aria-controls="collapseThree">
            n:m Beziehung
        </button>
    </div>
    <div id="collapseThree" class="collapse" aria-labelledby="headingManyMany" data-parent="#accordion">
        <div class="card-body">
            <p>
                Bei „viele zu viele“-Beziehungen in relationalen Datenbanken können jeder Entität eines
                Entitätstyps mehrere passende Entitäten des anderen an der Beziehung beteiligten
                Entitätstyps zugeordnet sein und umgekehrt.
                <br />
                <b>Beispiele:</b>
            <ul class="ovk-list">
                <li>
                    Schule: Ein/e Lehrer:in unterrichtet üblicherweise <span class="bold">mehrere</span>
                    Klassen und eine Klasse wird von <span class="bold">mehreren</span> Lehrer:innen
                    unterrichtet.<br />
                    <img style="max-width: 20em;"
                        src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/KardinalitätenMN-Klasse.svg"
                        alt='m:n - Beziehung Kunde ' id="er-diagramm" />
                </li>
                <li>
                    Shop: Ein/e Kund:in kauft <span class="bold">mehrere</span> Artikel
                    und ein Artikel kann von <span class="bold">mehreren</span> Kunden gekauft
                    werden.<br />
                    <img style="max-width: 18em;"
                        src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/KardinalitätenMN-Kaufen.svg"
                        alt='m:n - Beziehung Kunde ' id="er-diagramm" />
                </li>
            </ul>
            <div class="card ovk-hinweis">
                <div class="card-header">
                    <b>Hinweis</b>
                </div>
                <div class="card-body">
                    <p>
                        Bei n:m Beziehungen ist es möglich, auch den Beziehungstypen Attribute
                        zuzuordnen. In dem obigen Beispiel beschreibt das Attribut <code>Datum</code>
                        den Beziehungstyp <code>kaufen</code> näher, es handelt sich um das Kaufdatum.
                        Es ist weder sinnvoll, dieses Attribut dem Entitätstyp <code>Kunde</code>, noch
                        dem Entitätstyp <code>Artikel</code> zuzuweisen. Das Kaufdatum ist eindeutig der
                        Kombination beider Entitätstypen in der Beziehung &bdquo;Kunde <code>X</code>
                        kauft Artikel <code>Y</code> zum Zeitpunkt <code>Z</code>&ldquo; zugeordnet.
                    </p>
                </div>
                </p>
            </div>
        </div>
    </div>
</div> <!-- end diff akkordeon -->
<p>
    {{> video }} In diesem Video werden Kardinalitäten noch einmal genauer erklärt.
</p>
<iframe class="ovk-video"
    src="https://videocampus.sachsen.de/media/embed?key=a5571716ef47c8513f9fa1a08c300e76&width=480&height=300&autoplay=false&autolightsoff=false&loop=false&chapters=false&related=false&responsive=false&t=0"
    data-src="" class="iframeLoaded" width="480" height="300" frameborder="0"
    allowfullscreen="allowfullscreen" allowtransparency="true" scrolling="no">
</iframe>
<p>
<div class="card ovk-story">
    <div class="card-header schon-gewusst-header">
        {{> info }}
        <div style="padding-top: 0.2em;">Schon gewusst?</div>
    </div>
    <div class="card-body schon-gewusst-body">
        <p>
            <svg style="max-width: 17em;" class="ovk-grafik ovk-float-right" width="8cm"
                viewBox="362 213 359 139" xmlns="http://www.w3.org/2000/svg"
                xmlns:xlink="http://www.w3.org/1999/xlink">
                <g id="Hintergrund">
                    <g>
                        <rect class="ovk-svg-graphics entity" x="363" y="284" width="74.2"
                            height="36" />
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                            x="400.1" y="305.881">Knoten</text>
                    </g>
                    <g>
                        <polygon class="ovk-svg-graphics relationship" fill-rule="evenodd"
                            points="486,301.96 567.6,253 649.2,301.96 567.6,350.92 " />
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:end;font-family:monospace;font-style:normal;font-weight:normal"
                            x="480" y="295.96">n</text>
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:start;font-family:monospace;font-style:normal;font-weight:normal"
                            x="655.2" y="295.96">0..1</text>
                        <text font-size="12.8"
                            style="fill: #000000; fill-opacity: 1; stroke: none;text-anchor:middle;font-family:monospace;font-style:normal;font-weight:normal"
                            x="567.6" y="305.841">hat Elternknoten</text>
                    </g>
                    <polyline style="fill: none; stroke-opacity: 1; stroke-width: 2; stroke: #000000"
                        points="400.1,282.997 400.1,214 719.2,214 719.2,301.96 649.2,301.96 " />
                    <line style="fill: none; stroke-opacity: 1; stroke-width: 2; stroke: #000000"
                        x1="437.2" y1="302" x2="486" y2="301.96" />
                </g>
            </svg>
            Entitätstypen können auch zu sich selbst in Beziehung stehen. Ein Beispiel wäre die Entität
            Knoten, mit der eine Baumstruktur modelliert werden soll. Jeder Knoten des Baums hat genau
            einen Elternknoten, mit Ausnahme des Wurzelknotens, der keinen Elternknoten besitzt.<br />
            <b>Beachte</b>: Die Bezeichnung 0..1 steht für 0 oder 1, d.&nbsp;h. ein Knoten hat entweder
            genau einen Elternknoten oder keinen.
        </p>
    </div>
</div>
<h2>Kardinalitäten &ndash; Lückentext</h2>
<iframe src="https://ddivideo.inf.tu-dresden.de/wp-admin/admin-ajax.php?action=h5p_embed&id=28"
    width="958" height="324" frameborder="0" allowfullscreen="allowfullscreen"></iframe>
<script
    src="https://ddivideo.inf.tu-dresden.de/wp-content/plugins/h5p/h5p-php-library/js/h5p-resizer.js"
    charset="UTF-8"></script>
